# Script to check and mount a filesystem
# Copyright (C) 2019 William Haddon
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of version 2 of the GNU General Public License,
# as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1031 USA.

if [ X$1 = X ] || [ X$2 = X ] || [ X$3 = X ] || [ X$4 = X ]; then
	exit 0
fi
fsck -a $1
r=$?
if (expr $r \< 64 && expr $r % 4 \>= 2) > /dev/null; then
	echo requires reboot\; rebooting
	shutdown -r
	while true; do
		sleep 1
	done
elif (expr $r % 8 \>= 4 || expr $r % 16 \>= 8 || expr $r % 32 \>= 16) \
		> /dev/null; then
	echo filesystem will not be mounted
else
	if [ X$2 = X/ ]; then
		mount $1 $2 -t $3 -o $4 -o remount
	else
		mount $1 $2 -t $3 -o $4
	fi
	exit $?
fi
